package com.galaxis.manatee.service;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.dao.ChuanyunGroupProjectDao;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunGroupProjectDO;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunManagerProjectDO;
import com.galaxis.manatee.manager.ChuanYunManager;
import com.galaxis.manatee.task.ChuanyunBasicDataScheduledTask;
import lombok.extern.slf4j.Slf4j;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class ProjectMemberService {

    private final ChuanyunBasicDataScheduledTask chuanyunBasicDataScheduledTask;
    private final ChuanYunManager chuanYunManager;
    private final ChuanyunGroupProjectDao chuanyunGroupProjectDao;

    public ProjectMemberService(ChuanyunBasicDataScheduledTask chuanyunBasicDataScheduledTask, ChuanYunManager chuanYunManager, ChuanyunGroupProjectDao chuanyunGroupProjectDao) {
        this.chuanyunBasicDataScheduledTask = chuanyunBasicDataScheduledTask;
        this.chuanYunManager = chuanYunManager;
        this.chuanyunGroupProjectDao = chuanyunGroupProjectDao;
    }

    @Async
    public void updateMember(String param){
        var objectMapper=new ObjectMapper();
        param=param.substring(14,param.length()-2);
        var chuanyunFindResponse =  chuanYunManager.find(ChuanyunManagerProjectDO.SCHEMA_CODE,param);
        if (chuanyunFindResponse.getReturnData()!=null){
            ChuanyunManagerProjectDO chuanyunManagerProjectDO = objectMapper.convertValue(chuanyunFindResponse.getReturnData().getBizObject(), new TypeReference<>(){});
            log.info("管理项目"+chuanyunManagerProjectDO);
            ChuanyunGroupProjectDO chuanyunGroupProjectDO = chuanyunGroupProjectDao.findByProjectCode(chuanyunManagerProjectDO.getSeqNo());
            chuanyunBasicDataScheduledTask.chuanyunUpdateProjectMemberManually(chuanyunGroupProjectDO);
            log.info("更新项目组成员成功"+chuanyunGroupProjectDO);
        }else {
            log.info("更新项目组成员失败");
        }
    }
}
